#ifdef GL_ES
#define LOWP lowp
precision mediump float;
#else
#define LOWP
#endif

varying LOWP vec4 vColor;
varying vec2 vTexCoord;

uniform sampler2D u_texture;

void main() {
	vec4 color = texture(u_texture, vTexCoord)*vColor;
	float brightness = (color.r*0.2126) + (color.g*0.7152) + (color.b * 0.0722);
	
	if (brightness > 0.7) {
		gl_FragColor = color;
	} else {
		gl_FragColor = vec4(0.0);
	}
}
