package zero1hd.rhythmbullet.audio.visualizer;

import java.util.concurrent.locks.ReentrantLock;

import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.utils.Disposable;

import edu.emory.mathcs.jtransforms.fft.FloatFFT_1D;
import zero1hd.rhythmbullet.audio.MusicManager;

public class VisualizerCore implements Disposable {
	protected MusicManager mm;
	private FloatFFT_1D fft;
	float[] audioPCM;
	protected float width, height;
	protected float xPos, yPos;
	protected int barCount;
	private boolean calc;
	private ReentrantLock lock;
	public VisualizerCore(int width, int height, int x, int y) {
		this.height = height;
		this.width = width;
		this.xPos = x;
		this.yPos = y;
		
		lock = new ReentrantLock();
	}
	
	public void calculate() {
		if (mm != null) {
			mm.playbackIndexUpdate();
			lock.lock();
			while (calc && mm.isPlaying() && mm.getPlaybackIndexPosition() > mm.getCurrentReadWindowIndex()) {
				mm.readSamples(audioPCM);
				if (mm.getPlaybackIndexPosition() == mm.getCurrentReadWindowIndex()) {
					fft.realForward(audioPCM);
				}
			}
			lock.unlock();
		}
	}
	
	public void setMM(MusicManager mm) {
		lock.lock();
		if (audioPCM == null || audioPCM.length != mm.getReadWindowSize()) {
			calc = false;
			fft = new FloatFFT_1D(mm.getReadWindowSize());
		}
		audioPCM = new float[mm.getReadWindowSize()];
		this.mm = mm;
		calc = true;
		lock.unlock();
	}
	
	public void render(Batch batch, float parentAlpha) {
	}
	
	public void modify(float delta) {
	}
	
	@Override
	public void dispose() {
	}
	
	public void setxPos(float xPos) {
		this.xPos = xPos;
	}
	
	public void setyPos(float yPos) {
		this.yPos = yPos;
	}
	
	public void setWidth(float width) {
		this.width = width;
	}
	
	public void setHeight(float height) {
		this.height = height;
	}
	
	public float getxPos() {
		return xPos;
	}
	public float getyPos() {
		return yPos;
	}
	
	public float getWidth() {
		return width;
	}
	public float getHeight() {
		return height;
	}
	
	public MusicManager getMm() {
		return mm;
	}
}
